class Parser:
    '''

    num -> <число>
    group -> num | '(' add ')'
    mult -> group ( ('*' | '/') group )*
    add -> mult ( ('+' | '-') mult )*
    start -> add

    num -> <число>
    ident -> <идентификатор>
    params -> ( add ((',') add)* )?
    group -> num | ident '(' params ')' | '(' add ')'
    mult -> group ( ('*' | '/') group )*
    add -> mult ( ('+' | '-') mult )*
    start -> add

    num -> <число>
    ident -> <идентификатор>
    params -> ( add ((',') add)* )?
    group -> num | ident '(' params ')' | ident | '(' add ')'
    mult -> group ( ('*' | '/') group )*
    add -> mult ( ('+' | '-') mult )*
    stmt ->
        'print' add
      | ident '=' add
    program -> stmt*
    start -> program

    num -> <число>
    ident -> <идентификатор>
    params -> ( add ((',') add)* )?
    group -> num | ident '(' params ')' | '(' add ')'
    mult -> group ( ('*' | '/') group )*
    add -> mult ( ('+' | '-') mult )*
    expr -> add
    stmt ->
        'print' add
      | ident '=' add
      | '{' stmt* '}'
      | 'if' '(' expr ')' stmt ( 'else' stmt )?
    program -> stmt*
    start -> program
    '''


    def __init__(self, text: str):
        self.text = text + '$'
        self.pos = 0

    @property
    def curr(self) -> str:
        return self.text[self.pos]

    def num(self) -> float:
        tmp = ''
        while self.curr.isdecimal() or self.curr == '.':
            tmp += self.curr
            self.pos += 1
        return float(tmp)

    def group(self) -> float:
        if self.curr == '(':
            self.pos += 1
            res = self.add()
            self.pos += 1
            return res
        else:
            return self.num()

    def mult(self) -> float:
        res = self.group()
        while self.curr in ['*', '/']:
            op = self.curr
            self.pos += 1
            tmp = self.group()
            res = res * tmp if op == '*' else res / tmp
        return res

    def add(self) -> float:
        res = self.mult()
        while self.curr in ['+', '-']:
            op = self.curr
            self.pos += 1
            tmp = self.mult()
            res = res + tmp if op == '+' else res - tmp
        return res

    def start(self) -> float:
        return self.add()
